module NPhotons

using ProgressMeter, LinearAlgebra, DataStructures, NearestNeighbors, Distances, StaticArrays, Interpolations, CUDA, JLD2, FileIO, Random, Distributions, SpecialFunctions, Combinatorics, IterTools, DelimitedFiles, StatsBase, StatsFuns, Accessors, Arrow
import Humanize: digitsep
import BioStructures


# include("annealingState.jl")
include("AtomVolume.jl")
include("GaussianShellVolume.jl")
include("MixtureVolume.jl")
include("proposers.jl")
include("sampling.jl")
include("annealing.jl")
include("rotations.jl")
include("util.jl")
include("fsc.jl")
include("datagen.jl")
include("kernel.jl")
include("cuda.jl")
include("gradient.jl")
include("cuda_dense.jl")
include("multilevel.jl")
include("pdb.jl")
include("forwardmodel.jl")
include("compute.jl")
include("io.jl")

function monitor end

export AtomVolume, randomAtomVolume, normalizeScattering
export AbstractForwardModel, ForwardModel
export AbstractDetector, Detector, IdealDetector
export WeightedEnsemble, UniformEnsemble
export generateImage, generateImages, generateImagesThreaded
export IntegrationParameters, ComputeConfiguration, ComputeAllocation
export AbstractProposal, AdaptiveProposal, AlternatingProposal
export AbstractSampler, SimulatedAnnealing, AnnealingState
export nstepsRemaining, acceptanceRate
export align, aligned, fsc, fscResolution, randomRotation
export getpositions, getheights, getwidths, getconf, getenergy, gettemperature, getnsteps
export saveChain, loadChain, loadChainAsArray, exportJob, saveImages, loadImages

end
