using LinearAlgebra, ProgressMeter, JLD2, StaticArrays, Dates, FileIO, ArgParse, Glob, StatsBase, ThreadsX

import NPhotons as nph

const s = ArgParseSettings()
@add_arg_table! s begin
    "--nimages", "-n"
        default = 1000000
        arg_type = Int
    "--nfiles", "-N"
        default = 1
        arg_type = Int
    "infile"
        required = true
        arg_type = String
end

const A = (; parse_args(s, as_symbols = true)...)

function main()
    @load A.infile object forwardmodel qmax

    prog = Progress(A.nimages * A.nfiles)

    for i in 1:A.nfiles
        images = ThreadsX.map(1:A.nimages) do I
            next!(prog)
            nph.generateImage(object, forwardmodel, qmax = qmax)
        end
        nph.saveImages(splitext(A.infile)[1] * "_generated$i.jld2", images, metadata = (; object, forwardmodel, qmax))
    end
    
    finish!(prog)
end

main()
